mod Ex08a

incl Mtex

incl Mtexrc

incl Maux

loc rem 
  \para \bf  8. CVIČENIE Z PREDMETU 1-AIN-625 ÚVOD DO MATEMATICKEJ LOGIKY PRE 
  PROGRAMÁTOROV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Dátum:  \end utorok 6.11.2012 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-625-lpp/1213zs/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované obecne 
  rekurzívnym funkciam. Zadanie sa skladá z týchto súborov: 
  \items 
   \item \para Súbor(y) \it  mtex*.cl  \end obsahuje makrá pre CL-TeX. 
   \item \para Súbor(y) \it  maux*.cl  \end obsahuje definície niektorých 
         funkcií a predikátov. 
   \item \para Súbor(y) \it  ex*.cl  \end obsahuje úlohy, ktoré máte 
         riešiť na tomto cvičení. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje syntax systému CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Počet bodov za úlohy v tomto súbore: 0 
   \item \para Počet bodov za prémiove úlohy v tomto súbore:: 2 
  \end
  \para Odovzdať do 12.11.2012 (pondelok) do 12:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara. Recursive Functions. Downloadable 
         lecture notes available through the web page of the course. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [3]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
   \item \para \it  [4]  \end I. Korec. Úvod do teórie algoritmov. Skriptá 
         MFF UK, 1981. 
  \end

rem 
  \para \bf  [CL] CL-TeX.  \end 

appldisp/1 Tex_f1_rec_ack_b
  Std('b',0)

appldisp/2 Tex_f2_rec_ack_cvf
  Prefix(100,2,Underover(Id(1,'A',0),None,Op(Ent('OverBar'),0)),
         Fenced(Op('(',0),Infix(Arg(0),30,2,Op(',',0),Arg(1)),Op(')',0)))

rem 
  \para \bf  [CL] Membership predicate.  \end The predicate \ft x in y \end is 
  built into CL. Recall that we have 
  \eq* 
    x in y <-> \e i(i < L(y) & x = Sub(y,i))
  \end
  \para We write \ft x !in y \end as an abbreviation for \ft ~In(x,y) \end. 
  \para \it  Bounded quantification with membership predicate.  \end Note that 
  we have 
  \eq* 
    x in y -> x < y
  \end
  \para Consequently, existential and universal quantifiers in contexts like 
  \eq* 
    \e x(x in y & Tex0_dotsc)
  \end
  \eq* 
    \a x(x in y -> Tex0_dotsc)
  \end
  \para are in fact bounded. Such quantifiers can be used in explicit 
  definitions of predicates with bounded formulas. 
  \para \it  Syntax.  \end Examples: 
  \items 
   \item \para bounded quantifiers \ft \eb y y in x: R \end and 
         \ft \ab y y in x: R \end 
   \item \para \header* pred/2 Q  \end explicit definitions of predicates 
         \def 
           pred R 
           R(x) <-> \eb y y in x: Q(x,y)
         \end
         \def 
           pred R 
           R(x) <-> 
             \ab y y in x: Q(x,y)
         \end
  \end

rem 
  \para \bf  Chapter. General Recursive Functions.  \end 

rem 
  \para \bf  Section. Beyond Primitive Recursion: Ackermann Function.  \end 

rem 
  \para \bf  Subsection. Ackermann-Péter Function.  \end 

rem 
  \para \bf  Ackermann-Péter function.  \end 

fun/2 A 
  A(0,y) = y+1
  A(x+1,0) = A(x,1)
  A(x+1,y+1) = A(x,A(x+1,y))

rem 
  \para \bf  Course of values sequences.  \end The sequence \ft s \end is said 
  to be a course of values sequence for the Ackermann-Péter function if we have 
  \items 
   \item \para \ft s \end consists solely of triples of the form 
         \ft x,y,A(x,y) \end, i.e. 
         \eq* 
           \a a(a in s -> \e x\e y a = x,y,A(x,y))
         \end
   \item \para if \ft x,y,A(x,y) in s \end then \ft s \end contains all earlier 
         triples \ft x1,y1,A(x1,y1) \end that are needed to calculate 
         \ft A(x,y) \end 
  \end

rem 
  \para \bf  Course of values predicate.  \end By \ft Cvs(s) \end we denote the 
  predicate holding of course of values sequences for the Ackermann-Péter 
  function. Note that the predicate satisfies the following existence and 
  uniqueness conditions: 
  \eq* 
    \a x\a y\e s(Cvs(s) & \e z x,y,z in s)
  \end
  \eq* 
    Cvs(s1) & x,y,z1 in s1 & Cvs(s2) & x,y,z2 in s2 -> z1 = z2
  \end

rem 
  \para \bf  Exercise.  \end Show that the course of values predicate 
  \ft Cvs(s) \end is primitive recursive. 
  \para \it  Hint.  \end Note that we have 
  \eq* 
    A(x,y) = z -> x < z & y < z
  \end
  \eq* 
    A(0,y) = z <-> y+1 = z
  \end
  \eq* 
    A(x+1,0) = z <-> A(x,1) = z
  \end
  \eq* 
    A(x+1,y+1) = z <-> \eb v v < z: (A(x+1,y) = v & A(x,v) = z)
  \end

pred Cvs 
  Cvs(s) <-> Poo

rem 
  \para \bf  Exercise. \it  (bonus 2 points)  \end  \end \header* pred/3 G  \end 
  Show that the graph \ft G(x,y,z) \end of the Ackermann-Péter function 
  \eq* 
    G(x,y,z) <-> A(x,y) = z
  \end
  \para is primitive recursive. 

fun B 'Tex_f1_rec_ack_b'
  B(z) = Foo

pred/3 G 
  G(x,y,z) <-> Poo

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc rem 
  \para \it  Course of values function.  \end 
  \header* fun/2 Cvf 'Tex_f2_rec_ack_cvf' \end The following component contains 
  a double nested recursive definition of the course of values function 
  \ft Cvf(x,y) \end for the Ackermann-Péter function. The course of values 
  function satisfies 
  \eq* 
    Cvs Cvf(x,y)
  \end

loc fun/2 Cvf 'Tex_f2_rec_ack_cvf'
  Cvf(0,y) = (0,y,A(0,y)),0
  Cvf(x+1,0) = (x+1,0,A(x+1,0)),Cvf(x,1)
  Cvf(x+1,y+1) = (x+1,y+1,A(x+1,y+1)),Cvf(x+1,y)++Cvf(x,A(x+1,y))

loc rem 
  \para \it  Debugging.  \end 

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

